import React, { useState, useEffect } from 'react';
import { UploadOutlined } from '@ant-design/icons';
import { Input, Card, message, Radio, Select,Upload, Button } from 'antd';
import { FormattedMessage } from 'umi-plugin-react/locale';
import BuildSelect from '@/components/SelectButton/BuildSelectCourse'
import router from 'umi/router';
import { FieldTypes, createForm } from '@/components/XForm';
import Wangedit from '@/components/Wangedit/Wangedit'
// import channels from './channelList.less';
// import Tagss from '../components/Tagss.jsx';
import apis from '@/services/apis';
import request from '@/utils/request'
import BuildingSelection from '../components/BuildingSelection'
import { render } from 'react-dom';
import ImageUpload from '@/components/XForm/ImageUpload';
//下拉
function handleChange(value) {
  console.log(`selected ${value}`);
}
const { TextArea } = Input;
const { Option } = Select;
let consultantChecked = false;

const setExtraData = (data) => {
  consultantChecked = data.isConsultant
}

const handleFormValueChange = (props, changedValues, allValues) => {
    setExtraData(allValues)
}

const XForm = createForm({ onValuesChange: handleFormValueChange })

/**
 *
 *
 * @param {*} props
 * @returns
 */
const StaffEdit = (props) => {
  const roleId = props.location.query.roleId
  const [userData, setUserData] = useState({})
  const [tagData, setTagData] = useState([])
  const [roleData, setRoleData] = useState([])
  const [buildData, setBuildData] = useState([])
  const [visible, setVisible] = useState(false)
  //图文单选详情Radio
  const [newsDetailType, setNewsOenType] = useState(1);

  //视频组件
  
  const getVideo = {
    action: '//jsonplaceholder.typicode.com/posts/',
    listType: 'picture',
    previewFile(file) {
      console.log('Your upload file:', file);
      // Your process logic. Here we just mock to the same file
      return fetch('https://next.json-generator.com/api/json/get/4ytyBoLK8', {
        method: 'POST',
        body: file,
      })
        .then(res => res.json())
        .then(({ thumbnail }) => thumbnail);
    },
  };

  const getTagList = () => {
    request({ ...apis.staff.taTags, params: { pageNum: 1, pageSize: 999 } }).then((data) => {
      setTagData(data.records)
    })
  }

  const getRoleList = () => {
    request({ ...apis.role.getRoleList, params: { pageNum: 1, pageSize: 999 } }).then((data) => {
      console.log(data)
      setRoleData(data.records)
    })
  }

  //获取项目列表
  const getBuildList = e => {
    request({ ...apis.building.buildingSelect, params: { pageNum: 1, pageSize: 999 } }).then(data => {
        setBuildData(data)
    })
  }

  // 查询列表
  const getUserData = (roleId) => {
    request({ ...apis.staff.getTaUser, urlData: { id: roleId } }).then((data) => {
      consultantChecked = data.isConsultant
      setUserData(data)
      setNewsOenType(Number(data.newsDetailType))
    })
  }

  if(userData.buildingIds && buildData.length > 0 && !consultantChecked){
      const newBuildings = userData.buildingIds.filter(x => buildData.filter(it => it.buildingId === x)[0])
      userData.buildingIds = newBuildings
  }

  if(userData.roleIds && roleData.length > 0){
    const newRoleIds = userData.roleIds.filter(x => roleData.filter(it => it.roleId === x)[0])
      userData.roleIds = newRoleIds
  }

  useEffect(() => {
    getTagList();
    getRoleList();
    getBuildList();
    if (roleId) {
      getUserData(roleId);
    }
  }, [])

  // const tagsChange = (value) => {
  //   console.log(`selected ${value}`);
  // }

  const handleSubmit = val => {
    if (roleId) {
      request({ ...apis.course.alterCourse, urlData: { id: roleId }, data: val, }).then((data) => {
        console.log(data, "tauser")
        message.info("保存成功")
        router.go(-1)
      }).catch(error => {
        // message.info(error.message)
      })
    } else {
      request({ ...apis.course.addCourse, data: val, }).then((data) => {
        console.log(data, "tauser")
        message.info("保存成功")
        router.go(-1)
      }).catch(error => {
        // message.info(error.message)
      })
    }
  }


  //视频--------------------
 




  const photoBeforeUpload = (file) => {
    // const isJpgOrPng = file.type === 'image/jpeg' || file.type === 'image/png';
    // if (!isJpgOrPng) {
    //   message.error('请上传 JPG/PNG 格式的图片!');
    // }
    console.log(file.size, file.size / 1024)
    const isLt100k = (file.size / 1024) < 100;
    if (!isLt100k) {
      message.error('请上传小于100k的图片!');
    }
    return isLt100k;
  }
  const handleChange = (value) => {
    console.log(`selected ${value}`);
  }

  const fields = [
    {
      label: '参与对象',
      name: 'roleId',
      render:<Select  initialValue={'0'} style={{ width: 200 }}>
        <Option value='0'>置业顾问</Option>
        <Option value='1'>经纪人</Option>
        <Option value='2'>置业顾问&amp;经纪人</Option>
      </Select> ,
      rules: [
        { required: true, message: '请输入参与对象' },
      ],
    },
    {
      label: '主图',
      name: 'curriculumImg',
      type: FieldTypes.ImageUploader,
      extra: '建议尺寸：750px*600px，比例5:4，格式：jpg，用于：列表和详情',
      value: userData.curriculumImg,
      // render:<ImageUpload/>,
      // beforeUpload: (e) => photoBeforeUpload(e),
      rules: [
        { required: true, message: '主图' },
      ]
    },

    {
      label: '课程标题',
      name: 'content',
      render: <Input style={{width:'550px'}} ></Input>,
      value: userData.usernew,
    
      // className={channels.inpuitTxt}
      rules: [
        { required: true, message: '请输入课程标题' },
      ]
    },
    {
      label: '简介',
      name: 'remark',
      render: <TextArea  style={{width:'550px'}}  rows='5' ></TextArea>,
      value: userData.description,
      rules: [
        { required: true, message: '请输入简介' },
      ]
  
      // className={channels.inpuitTxt}
    },
    {
      label:'详情',
      name:'newsOen',
      render:(
        <Radio.Group 
        onChange={e=>{
          setNewsOenType(e.target.value)
        }} >
          <Radio value='1'>图文</Radio>,
          <Radio value='0'>视频</Radio>,
        </Radio.Group>
      ),
      value:userData,
      rules: [{ required: true, message: '请选择详情类型' }],

    },
    {
      label: '详情内容',
      name: 'newsDetail',
      render: <Wangedit />,
      hidden: newsDetailType == 0,
      value: userData.newsDetail,
      rules: [{ required: true, message: '请输入详情内容' }],
    },
    {
      label:'视频详情',
      name:'newVideo',
      hidden: newsDetailType == 1,
      value:userData.newVideo,
      render: <Upload {...getVideo} maxCount='1' accept='.avi,.mp4,.wmv,.flv'>
      <Button ><UploadOutlined />上传视频</Button>
    </Upload>,
      extra: '仅支AVI、MP4、WMV、FIV格式视频',
    rules:[{required:true,message:'请上传视频详情'}]
    },
    {
      label: '权重',
      name: 'weight',
      type: FieldTypes.Number,
      render: <Input type="number" style={{ width: 150}} />,
      value: '1',
      help: '数字越大越靠前',
    },
  ]

  return <Card>
            <XForm onChange={console.log} onSubmit={handleSubmit} fields={fields.filter(Boolean)} onCancel={() => router.go(-1)}></XForm>
        </Card>
}
export default StaffEdit
